//////////////////
// DrawBitmap.c //
//////////////////

// Petzold, 1996, 190-191.

// Unscaled transfer of bitmap to screen.

#define STRICT
#include <windows.h>

void
DrawBitmap(HDC hdc, HBITMAP hBitmap, int xStart, int yStart)
{
	BITMAP		bm;
	HDC			hdcMem;
	POINT		ptSize, ptOrg;

	// Create memory device context and put bitmap into it
	hdcMem = CreateCompatibleDC(hdc);
	SelectObject(hdcMem, hBitmap);
	SetMapMode(hdcMem, GetMapMode(hdc));

	// Find physical dimensions of pixels so BitBlt won't scale bitmap
	GetObject(hBitmap, sizeof(BITMAP), (LPVOID)(&bm));
	ptSize.x = bm.bmWidth;
	ptSize.y = bm.bmHeight;
	DPtoLP(hdc, &ptSize, 1);	// BitBlt uses logical coords

	ptOrg.x = 0;
	ptOrg.y = 0;
	DPtoLP(hdcMem, &ptOrg, 1);	// BitBlt uses logical coords

	// Copy over the bitmap
	BitBlt(hdc, xStart, yStart, ptSize.x, ptSize.y,
		hdcMem, ptOrg.x, ptOrg.y, SRCCOPY);

	DeleteDC(hdcMem);
}
