/*
 * Computations based on date and time of day
 * Bruce R. Julian, USGS Menlo Park, CA
 */
#include <math.h>
#include "local.h"
#include "datetime.h"

/* Convert date and time to double */
double
timvar(int yr, int mo, int da, int hr, int mn, double sec, int caltyp)
{
	return (double)DAY * (jdn(yr, mo, da, caltyp) - BASEJDN) +
		HOUR * hr + MINUTE * mn + SECOND * sec;
}

/* Convert double to date and time */
void
datime(double t,
	   int * pyr, int * pmo, int * pda, int * phr, int * pmn, double * psec,
	   int caltyp)
{
	long    d;

	d = (long)floor(t / DAY);
	date(d + BASEJDN, pyr, pmo, pda, caltyp);
	t -= d * DAY;
	*phr = (int)(t / HOUR);
	t -= (*phr) * HOUR;
	*pmn = (int)(t / MINUTE);
	*psec = t - (*pmn) * MINUTE;
}
