/*             D A T E _ T I M E . H
 * Include file for calendar and time routines
 * Bruce R. Julian, USGS Menlo Park, Calif.
 */
#ifndef DATETIME_H
#define DATETIME_H

#define	BASEJDN		2440588			/* 1 January 1970	*/

/* Calendar codes */
#define	GREGORIAN	1			/* Modern calendar	*/
#define	JULIAN		0			/* Old-style calendar	*/

/* Time intervals */
#define	SECOND		1
#define	MINUTE		(60*SECOND)
#define	HOUR		(60*MINUTE)
#define	DAY			(24*HOUR)
#define	WEEK		(7*DAY)
#define	YEAR		(365*DAY)
#define	LEAPYEAR	(366*DAY)
#define	MILLISEC	(1e-3*SECOND)
#define	MICROSEC	(1e-6*SECOND)
#define	NANOSEC		(1e-9*SECOND)

/* Function prototypes */
// double	atotime();
int		ckdate(int, int, int, int);
void	date(long, int *, int *, int *, int);
void	datime(double, int *, int *, int *, int *, int *, double *, int);
BOOL	isleap(int, int);
long	jdn(int, int, int, int);
void	mnday(int, BOOL, int *, int *);
double	timvar(int, int, int, int, int, double, int);
int		yrday(int, int, BOOL);

#endif DATETIME_H
