#ifndef lint
static char rcsid[]="$Header: /home1/crhet/julian/src/lib/libq/RCS/error.c,v 1.10 1999/05/17 22:34:50 julian Exp $";
#endif
/*
 * Error reporting and handling package
 * Bruce R. Julian, USGS Menlo Park, Calif.
 */
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include "compat.h"
#include "stdtyp.h"
#include "local.h"
#include "libq.h"

#ifndef EXIT_FAILURE
#define EXIT_FAILURE 1
#endif

extern	int	sys_nerr;
extern	int	errbase, nerr;
extern	char	*sys_errlist[], *q_errlist[];
extern	int	errno;
extern	char	*progname;

/* Return error message */
char
*ermsg(ier)
	int	ier;
{
static	char	s[12];

	if (ier == 0)
		return (NULL);
	if (ier > 0 && ier < sys_nerr)
		return (sys_errlist[ier]);
	ier -= errbase;
	if (ier > 0 && ier < nerr)
		return (q_errlist[ier]);
	else
		return (sprintf(s, "Error %d", errbase+ier), s);
}

/* Print error message */
/*VARARGS*/
#ifdef __STDC__
static void
msg(const char* fmt, va_list args)
#else
static void
msg(va_alist)
	va_dcl
#endif
{
#ifndef __STDC__
	va_list	args;
#endif
	time_t	clock;		/* Current system time			*/
#ifndef __STDC__
	char	*fmt;		/* Format string			*/
#endif
	char	*p;		/* Error message			*/

	clock = time((time_t *)NULL);
	fprintf(stderr, "%.24s ", ctime(&clock));
	if (progname)
		fprintf(stderr, "%s: ", progname);
#ifndef __STDC__
	fmt = va_arg(args, char*);
#endif
	vfprintf(stderr, fmt, args);
	if ((p = ermsg(errno)) != NULL)
		fprintf(stderr, " (%s)", p);
	fprintf(stderr, "\n");
}

/* Print error message but don't die */
/*VARARGS*/
#ifdef __STDC__
void
report(const char* fmt, ...)
#else
void
report(va_alist)
	va_dcl
#endif
{
	va_list	args;

#ifdef __STDC__
	va_start(args, fmt);
#else
	char    *fmt;
	va_start(args);
	fmt = va_arg(args, char*);
#endif
	msg(fmt, args);
	va_end(args);
}

/* Print error message and die */
/*VARARGS*/
#ifdef __STDC__
void
error(const char* fmt, ...)
#else
void
error(va_alist)
	va_dcl
#endif
{
	va_list	args;

#ifdef __STDC__
	va_start(args, fmt);
#else
	char	*fmt;
	va_start(args);
	fmt = va_arg(args, char*);
#endif
	msg(fmt, args);
	va_end(args);
	exit(EXIT_FAILURE);
}
