/*
 * libq.h
 * Public header file for libq library.
 */
#include "compat.h"

double	atoangle PARMS((const char *p));
void	back PARMS((double delta, double az0, double *lat, double *lon));
char*	basename PARMS((char* path, char* ext, char* base));
void	bndsol PARMS((const float** a, int n, int k, int l, float* b));
void	bndtri PARMS((float** a, int n, int k, int l));
int	bsstep PARMS((float *y, float *dydx, int n, float *xx,
		double htry, double eps, float *yscal,
		float *hdid, float *hnext,
		void (*derivs)(double x, const float* y, float* dy)));
#if     defined (FILE) || defined(_STDIO_H)
void	clkcor PARMS((FILE *f,
		int y, int d, int h, int m, double s,
		double *c, double *sigma_t));
#endif
char**	cmatrix PARMS((int rl, int rh, int cl, int ch));
void	cvcsd PARMS((double x, double y, double z,
		double *r, double *theta, double *phi));
void	cvctos PARMS((double x, double y, double z,
		float *r, float *theta, float *phi));
char*	cvector PARMS((int l, int h));
float**	cvfmatrix PARMS((float *a, int rl, int rh, int cl, int ch));
void	cvprd PARMS((double r, double theta, double *x, double *y));
void	cvptor PARMS((double r, double theta, float *x, float *y));
void	cvrpd PARMS((double x, double y, double *r, double *theta));
void	cvrtop PARMS((double x, double y, float *r, float *theta));
void	cvscd PARMS((double r, double theta, double phi,
		double *x, double *y, double *z));
void	cvstoc PARMS((double r, double theta, double phi,
		float *x, float *y, float *z));
void	daxpy PARMS((int n, double a, const double *x, double *y));
int	dbsstep PARMS((double *y, double *dydx, int n, double *xx,
		double htry, double eps, double *yscal,
		double *hdid, double *hnext,
		void (*derivs)(double x, const double* y, double* dy)));
void	dcback PARMS((double cosd, double sind,
		double cosz, double sinz,
		double b[3]));
void	dcbaz PARMS((const double b[3], double *cosz, double *sinz));
void	dcdaz PARMS((const double b[3],
		double *cosd, double *sind,
		double *cosz, double *sinz));
void	dcopy PARMS((const double *a, double *b, int n));
void	dcrefpt PARMS((const double g[3]));
double	ddot PARMS((const double *a, const double *b, int n));
void	delaz PARMS((double lat, double lon,
		double *delta, double *az0, double *az1));
void	dispcf PARMS((double x, double y, double d, double nu,
		double ux[6], double uy[6], double uz[6]));
double**	dmatrix PARMS((int rl, int rh, int cl, int ch));
double	dmax PARMS((const double *a, int n));
double	dmin PARMS((const double *a, int n));
void	dmmid PARMS((const double y[], const double dydx[], int n,
		double xs, double htot, int nstep, double yout[],
		void (*derivs)(double x, const double* yn, double* yout)));
double	dot PARMS((const float *a, const float *b, int n));
double*	dptor PARMS((double r, double theta, double* v));
void	dscale PARMS((double *a, int n, double v));
void	dset PARMS((double *a, int n, double v));
double*	dstoc PARMS((double r, double theta, double phi, double* v));
void	dswap PARMS((double *a, double *b, int n));
double*	dvector PARMS((int l, int h));
char*	ecalloc PARMS((unsigned int n, unsigned int s));
#if     defined (FILE) || defined(_STDIO_H)
FILE*	efopen PARMS((const char* name, const char* mode));
FILE*	efdopen PARMS((int fd, const char* mode));
#endif
void	eigsrt PARMS((float *d, float **v, int n));
char*	emalloc PARMS((unsigned int s));
int	eopen PARMS((const char *file, int mode));
char*	erealloc PARMS((char *p, unsigned int s));
char	*ermsg PARMS((int ier));
void	error PARMS((const char* fmt, ...));
void	euler PARMS((double phi, double theta, double psi,
		float a[3][3]));
char*	exesc PARMS((char* s, char* t));
int	falsem PARMS((double (*f)(double), double a, double b,
		double e, int n,
		double *x));
float	famax PARMS((const float *a, int n));
float*** farray3 PARMS((int l1, int h1, int l2, int h2, int l3, int h3));
void	faxpy PARMS((int n, double a, const float *x, float *y));
#if     defined (FILE) || defined(_STDIO_H)
void	fbsearch PARMS((FILE *f, int (*compare)(const char*)));
#endif
void	fcopy PARMS((const float *a, float *b, int n));
void	fcvfmatrix PARMS((float **b, int rl, int rh, int cl, int ch));
float**	fmatrix PARMS((int rl, int rh, int cl, int ch));
float	fmax PARMS((const float *a, int n));
void	fmdcmp PARMS((float pmom[3], float th[3], float ph[3],
		float *mv, float *mdc, float *mclvd,
		float tdc[3], float pdc[3],
		float *tclvd, float *pclvd));
float	fmin PARMS((const float *a, int n));
void	four1 PARMS((float data[], int nn, int isign));
void	fpcf PARMS((const float g[3], float a[3]));
float*	fptor PARMS((double r, double theta, float* v));
void	free_cmatrix PARMS((char **m, int rl, int rh, int cl, int ch));
void	free_cvector PARMS((char *v, int l, int h));
void	free_dmatrix PARMS((double **m, int rl, int rh, int cl, int ch));
void	free_dvector PARMS((double *v, int l, int h));
void	free_fa3 PARMS((float*** a,
		int l1, int h1, int l2, int h2, int l3, int h3));
void	free_fmatrix PARMS((float **m, int rl, int rh, int cl, int ch));
void	free_fsubmatrix PARMS((float **b, int rl, int rh, int cl, int ch));
void	free_fvector PARMS((float *v, int l, int h));
void	free_imatrix PARMS((int **m, int rl, int rh, int cl, int ch));
void	free_ivector PARMS((int *v, int l, int h));
void	fscale PARMS((float *a, int n, double v));
void	fscf PARMS((const float g[3], float p[3], float a[3]));
void	fset PARMS((float *a, int n, double v));
void	fshcf PARMS((const float g[3], float a[3]));
void	fsvcf PARMS((const float g[3], float a[3]));
float*	fstoc PARMS((double r, double theta, double phi, float* v));
float**	fsubmatrix PARMS((float **a, int rl, int rh, int cl, int ch,
		int newrl, int newcl));
void	fswap PARMS((float *a, float *b, int n));
float*	fvector PARMS((int l, int h));
float	gammln PARMS((double xx));
float	gammp PARMS((double a, double x));
float	gammq PARMS((double a, double x));
int	gaussj PARMS((float **a, int n, float **b, int m));
void	gcf PARMS((float *gammcf, double a, double x, float *gln));
double	gctogg PARMS((double lat));
double	get_allan PARMS((void));
int	getpat PARMS((char *s, char *pat));
double	ggtogc PARMS((double lat));
void	gser PARMS((float *gamser, double a, double x, float *gln));
void	guessray PARMS((float* x, float* y, float* z, int n, double vz));
int	hunt PARMS((const float xx[], int n, double x, int jlo));
double	hypot PARMS((double a, double b));
int	idamax PARMS((const double *a, int ia, int n));
int	ifamax PARMS((const float *a, int ia, int n));
int**	imatrix PARMS((int rl, int rh, int cl, int ch));
int	inpoly PARMS((double x0, double y0, const float* px, const float* py, int n));
int*	ivector PARMS((int l, int h));
void	jacobi PARMS((float **a, int n, float d[], float **v, int *nrot));
int	locate PARMS((float xx[], int n, double x));
void	lubksb PARMS((const float **a, int n, const int *indx, float b[]));
void	ludcmp PARMS((float **a, int n, int *indx, float *d));
int	match PARMS((char *s, char *pat));
void	mmid PARMS((const float y[], const float dydx[], int n,
		double xs, double htot, int nstep, float yout[],
		void (*derivs)(double x, const float* yn, float* yout)));
void	mt3pcf PARMS((const float g[3], float a[3][6]));
void	mt3shcf PARMS((const float g[3], float a[3][6]));
void	mt3svcf PARMS((const float g[3], float a[3][6]));
void	mtpcf PARMS((const float g[3], float a[6]));
void	mtscf PARMS((const float g[3], const float p[3], float a[6]));
void	mtshcf PARMS((const float g[3], float a[6]));
void	mtsvcf PARMS((const float g[3], float a[6]));
void	osimxfm PARMS((float m[3][3], const float a[3][3]));
#if     defined (FILE) || defined(_STDIO_H)
void	pcfcor PARMS((FILE *f,
		int y, int d, int h, int m, double s,
		double *c, double *sigma_t));
void    pcfseek PARMS((FILE* f, int y, int d, int h, int m, double s));
#endif
float	pctil PARMS((float a[], int n, double pct));
void	peuler PARMS((double phi, double theta, double psi, float **a));
float*	phi_hat PARMS((const float g[3], float v[3]));
void	prax PARMS((const float tensor[6], float *pval, float *t, float *p));
float	qantil PARMS((float a[], int n, int k));
void	realft PARMS((float* data, unsigned int n, int isign));
void	refpt PARMS((double lat, double lon));
void	report PARMS((const char* fmt, ...));
int	rtsafe PARMS((double (*f)(double x, double* y, double* dy),
		double x1, double x2, double e, int n,
		double *root));
void	sdr PARMS((const float n[3], const float s[3],
		float *strike, float *dip, float *rake));
void	set_allan PARMS((double));
void	set_ellipsoid PARMS((double f));
void	straincf PARMS((double x, double y, double d, double nu,
		double uxx[6], double uxy[6],
		double uyx[6], double uyy[6]));
float*	theta_hat PARMS((const float g[3], float v[3]));
void	tiltcf PARMS((double x, double y, double d, double nu,
		double uzx[6], double uzy[6]));
char*	verify PARMS((const char *a, const char *b));
