/*
 * lnklst.h - Generic linked lists
 */
#ifndef LNKLST_H
#define LNKLST_H

#include <stdlib.h>
#include <malloc.h>

typedef int Bool;

#define ll_len(l)	(l->lstlen)

typedef struct LINKTYPE {
	struct LINKTYPE	*next;
	struct LINKTYPE	*prev;
	char			*item;
} LNKTYP;

typedef struct {
	LNKTYP			head;
	LNKTYP			*tail;
	LNKTYP			*clp;
	int				lstlen;	/* Zero if only the (NULL) head item exists */
} LNKLST;

LNKLST	*ll_open(void);
BOOL	ll_next(LNKLST *);
BOOL	ll_prev(LNKLST *);
void	ll_head(LNKLST *);
void	ll_tail(LNKLST *);
int		ll_find(LNKLST *, char *, Bool(*fmatch)(/* char *, char * */));
char	*ll_ret(LNKLST *);
void	ll_add(LNKLST *, char *);
char	*ll_delete(LNKLST *);
void	ll_close(LNKLST *, void (*fdel)(/* char* */));

#endif LNKLST_H
