/*
 * local.h
 * Public header file of useful stuff.
 * Bruce R. Julian, USGS Menlo Park Calif., Nov 15 1998
 */
#ifndef LOCAL_H
#define LOCAL_H

#include "stdtyp.h"

#ifndef NULL
#define NULL 0
#endif NULL

#define PRIVATE	static				/* Better name for it	*/
#define FOREVER for(;;)				/* Infinite loop	*/
typedef int Bool;
#define NOT !
#define YES 1					/* Truth value		*/
#define NO 0					/* Truth value		*/
#ifndef TRUE
#define TRUE 1					/* Truth value		*/
#define FALSE 0					/* Truth value		*/
#endif TRUE
#define DIM(x) (sizeof(x)/sizeof((x)[0]))	/* Dimension of array	*/
#ifndef MAX
#define MAX(a,b) (((a)>(b)) ? (a) : (b))	/* Larger value		*/
#endif MAX
#ifndef MIN
#define MIN(a,b) (((a)<(b)) ? (a) : (b))	/* Smaller value	*/
#endif MIN
#define ABS(a) ((a) > 0 ? (a) : -(a))		/* Absolute value	*/
#define FAIL -1					/* Function return	*/
#define FAILED == -1
#define SUCCEED 0				/* Function return	*/
#define SUCCEEDED != -1
#define STDIN 0					/* read() write() unit	*/
#define STDOUT 1				/* read() write() unit	*/
#define STDERR 2				/* read() write() unit	*/
#define READ 0					/* Mode for open()	*/
#define WRITE 1					/* Mode for open()	*/
#define UPDATE 2				/* Mode for open()	*/
#define HEAD 0					/* Whence for lseek()	*/
#define HERE 1					/* Whence for lseek()	*/
#define TAIL 2					/* Whence for lseek()	*/
#define dcopy(a, b, n) if ((n) > 0) memcpy((void*)(b), (void*)(a), (n)*sizeof(double));
#define fcopy(a, b, n) if ((n) > 0) memcpy((void*)(b), (void*)(a), (n)*sizeof(float));
#define reg register
#define repeat do
#define until(c) while(!(c))
#define streq !strcmp				/* String comparison	*/
#define strcaseeq !strcasecmp			/* String comparison	*/
#define strneq !strncmp				/* String comparison	*/

#define ALLOC(x) (struct x *) malloc(sizeof(struct x))

#define TURN_ON(x, f)   (x |= (f))
#define TURN_OFF(x, f)   (x &= ~(f))
#define IS_ON(x, f)   (x & (f))
#define IS_OFF(x, f)   (!(x & (f)))

#endif LOCAL_H
