/*                     q e r r . h
 * Bruce R. Julian, USGS Menlo Park Calif., 15 Dec. 1983
 */
#ifndef QERR_H
#define QERR_H

#define ERRBASE		1000
#define EBADDAY		(ERRBASE +  1)	/* Illegal day			*/
#define EBADMONTH	(ERRBASE +  2)	/* Illegal month		*/
#define EBADYEAR	(ERRBASE +  3)	/* Illegal year			*/
#define EBADVALUE	(ERRBASE +  4)	/* Illegal value		*/
#define EFEWDATA	(ERRBASE +  5)	/* Not enough data		*/
#define ENOCONVRG	(ERRBASE +  6)	/* Convergence Failure		*/
#define EUNDERFLOW	(ERRBASE +  7)	/* Underflow			*/
#define ENOSTATION	(ERRBASE +  8)	/* No such station		*/
#define ESIZE		(ERRBASE +  9)	/* Inappropriate structure size	*/
#define ESINGULAR	(ERRBASE + 10)	/* Singular matrix		*/
#define ETOODEEP	(ERRBASE + 11)	/* Focal depth too great	*/
#define EBADPHASE	(ERRBASE + 12)	/* No such phase		*/
#define ENOFEAS		(ERRBASE + 13)	/* Constraints are inconsistent	*/
#define EINFIN		(ERRBASE + 14)	/* Solution is unbounded	*/
#define ENOTFOUND	(ERRBASE + 15)	/* Can't find desired record	*/
#define ENOCUROR	(ERRBASE + 16)	/* No current origin		*/
#define ENOCURAM	(ERRBASE + 17)	/* No current average magnitude	*/
#define ECANTBRACKET	(ERRBASE + 18)	/* Root not bracketed		*/
#endif QERR_H
